<?php
// iso.php

// Parametreja
$serverpath = dirname($_SERVER['SCRIPT_FILENAME']);
$datapath   = "/";
$datadir    = "$serverpath" . "$datapath";
$isofile    = "iso.htm";
$indexfile  = "sisallys.htm";

if (!($files = tiedostonimet_taulukkoon($datadir))){
    die("Ei yhdistettvi tiedostoja!");
}

yhdista_filet($datadir, $isofile, $files, $indexfile);


/******************** Aliohjelmat ********************/

// Funktio palauttaa $datadir-hakemiston tiedostojen
// nimet taulukossa, jos niiden muoto on vaadittu:
// 00.htm, 01.htm, ..., 99.htm. Jos vaadittuja
// tiedostoja ei lydy, palautetaan FALSE.
function tiedostonimet_taulukkoon($datadir) {
   $handle = opendir($datadir);
   while ($file = readdir($handle)) {
      if (is_file("$datadir" . "$file")) {
         if (ereg("^[0-9]{2}\.htm$",$file)) {
            $files[] = $file;
         }
      }
   }
   closedir($handle);
   
   if (count($files) > 0) {
      sort($files);
   } else {
      $files = FALSE;   
   }
   return $files;
}

// Yhdistetn $index-tiedoston ja $files-taulukon tiedostot
// yhdeksi HTML-tiedostoksi
function yhdista_filet($datadir, $isofile, $files, $indexfile) {
   // Avataan tulostiedosto kirjoittamista varten
   $isofilename = $datadir . $isofile;
   if (!$fp = @fopen($isofilename, "w")) {
      die("Tiedoston $isofilename avausvirhe!");
   }
   
   // Kirjoitetaan sisllysluettelotiedoston alkuosa ja
   // BODY-elementti tulostiedostoon
   $filename = $datadir . $indexfile;
   if (!$tmp_file = file_get_contents($filename)) {
      die("Sisllysluettelotiedoston $filename avausvirhe!");
   }
   $iso_file = eregi_replace ("</body>.*", "", $tmp_file);
   fwrite ($fp, $iso_file);
   
   // Kirjoitetaan $files-taulukon tiedostojen BODY-elementit
   // tulostiedostoon.
   $file_lkm = count($files);
   for ($i = 0; $i < $file_lkm; $i++) {
      $filename = $datadir . $files[$i];
      fwrite_html_body($filename, $fp);
   }

   // Kirjoitetaan tulostiedoston loppukommentit
   fwrite($fp, "<hr>Generoitu: Ari Rantala<code>" . 
                date("d.m.Y") . "</code></body>\n</html>");    
   fclose($fp);
   echo "VALMIS: <a href='$isofile'>$isofile</a>";
}

// Kirjoitetaan HTML-tiedoston $sourcefile BODY-
// elementin sislt $fp:n osoittamaan tiedostoon
function fwrite_html_body($sourcefile, $fp) {
   $eka_rivi_loytynyt    = FALSE;
   $vimppa_rivi_loytynyt = FALSE;

   if (!($fp_luetaan = fopen($sourcefile, "r"))){
      die("Tiedoston $sourcefile avausvirhe!");
   }

   while(!feof($fp_luetaan) AND !$vimppa_rivi_loytynyt) {
       $rivi = fgets($fp_luetaan, 1024);
       if (eregi("<body[^>]*>(.*)", $rivi, $regs)) { 
          fwrite ($fp, $regs[1]);
          $eka_rivi_loytynyt = TRUE;
       } elseif (eregi("(.*)</body>", $rivi, $regs)) {
          fwrite ($fp, $regs[1]);
          $vimppa_rivi_loytynyt = TRUE;
       } elseif ($eka_rivi_loytynyt) {
           fwrite ($fp, $rivi);
       } else {
           // Ei tehd mitn, ollaan alueella ennen
           // aloittavaa BODY-tagia.
       }
   }
   fclose($fp_luetaan);
}
?>
